#!/bin/bash

# $1 is scriptpath to this plugin
export DEBIAN_FRONTEND=noninteractive
VERSION=$(lsb_release -a 2>/dev/null | grep "Codename" | sed "s/Distributor ID:\t//;s/Codename:\t//")

apt-get update

if [ "$VERSION" == "jessie" ]; then
	apt-get -y install php5-curl php5-mysql php5-cli curl --yes
else	
	if [ ! -n "$(find /etc/apache2/mods-enabled -name 'php7.[1-9]*' | head -1)" ]; then
		# if Stretch & Apache not using php7.4
		sudo apt install -y ca-certificates apt-transport-https 
		wget -q https://packages.sury.org/php/apt.gpg -O- | sudo apt-key add -
		echo "deb https://packages.sury.org/php/ stretch main" | sudo tee /etc/apt/sources.list.d/php.list
		apt-get update

	    sudo apt -y install lsb-release apt-transport-https ca-certificates
        sudo wget -O /etc/apt/trusted.gpg.d/php.gpg https://packages.sury.org/php/apt.gpg
	    echo "deb https://packages.sury.org/php/ $(lsb_release -sc) main" | sudo tee /etc/apt/sources.list.d/php.list
        apt-get update

	    apt-get install php7.4 -y
		apt-get install php7.4-cli php7.4-common php7.4-curl php7.4-mbstring php7.4-mysql php7.4-gd php7.4-xml php7.4-intl -y
		a2dismod php5
		a2dismod php7.0
		a2enmod php7.4
		echo ""
		echo "finished upgrade to PHP 7.4 - Webserver configuration changed and updated"
		echo "!!! Please refresh Page and restart Installation again !!!"
		echo "!!! Important: Ampache is not installed yet - click install one more time !!!"
		echo ""
		sleep 4
		systemctl restart apache2
		echo ""		
		exit 0
	fi
	
	if [ "$VERSION" == "buster" ]; then
		if [ ! -n "$(find /etc/apache2/mods-enabled -name 'php7.4*' | head -1)" ]; then
		    apt-get update
		    apt -y install lsb-release apt-transport-https ca-certificates
            wget -O /etc/apt/trusted.gpg.d/php.gpg https://packages.sury.org/php/apt.gpg
	        echo "deb https://packages.sury.org/php/ $(lsb_release -sc) main" | sudo tee /etc/apt/sources.list.d/php.list
            apt-get update
	        apt-get install php7.4 -y
		    apt-get install php7.4-cli php7.4-common php7.4-curl php7.4-mbstring php7.4-mysql php7.4-gd php7.4-xml php7.4-intl -y
		    a2dismod php7.3
		    a2enmod php7.4
		    echo ""
            echo "finished upgrade to PHP 7.4 - Webserver configuration changed and updated"
            echo "!!! Please refresh Page and restart Installation again !!!"
            echo "!!! Important: Ampache is not installed yet - click install one more time !!!"
            echo ""
            sleep 4
            systemctl restart apache2
            echo ""
            exit 0
		fi
		apt-get -y install php7.4-mysql php7.4-curl php7.4-cli php7.4-gd php7.4-xml php7.4-mbstring php7.4-intl --yes
		apt-get -y install php7.4-xml php7.4-mbstring php7.4-gettext --yes
	else
		#apt-get -y install php-mysql php-curl php-cli php-gd php-simplexml php7.0-mbstring --yes
		apt-get install php7.4-cli php7.4-common php7.4-curl php7.4-mbstring php7.4-mysql php7.4-xml php7.4-gettext --yes
	fi
	apt-get -y install libapache2-mod-php7.4 --yes
fi

debconf-set-selections <<< 'mysql-server mysql-server/root_password password max2play'
debconf-set-selections <<< 'mysql-server mysql-server/root_password_again password max2play'
apt-get -y install mysql-server
if [ "$VERSION" == "buster" ]; then
	apt-get -y install mariadb-server-10.0
else
	apt-get -y install mysql-server
fi

if [ "$VERSION" == "stretch" -o "$VERSION" == "buster" ]; then
	echo "Set MySQL-Password"
	mysql --database=mysql -e "UPDATE user SET password=PASSWORD('max2play'), plugin='' WHERE user='root';FLUSH PRIVILEGES;"
fi
pushd /var/www

#git clone https://github.com/ampache/ampache.git
# Problem ampache.sql - https://github.com/ampache/ampache/issues/3254
# manually create Tables?
##`metadata_field`
##`tag`
##`session`
##`session_remember`
git clone -b release5 https://github.com/ampache/ampache.git ampache

cp $1/ampache.conf /etc/apache2/sites-enabled/

chown -R www-data /var/www/ampache
chmod -R 777 /var/www/ampache

pushd /usr/src
curl -sS https://getcomposer.org/installer | sudo php
sudo mv composer.phar /usr/local/bin/composer

pushd /var/www/ampache
# Replace Condition for php7.4 with 7.4 - Better upgrade to php7.4
#sed -i 's/php7.4/php7.4/' /var/www/ampache/composer.json

/usr/local/bin/composer install --prefer-source --no-interaction

/etc/init.d/apache2 reload

echo "finished - <b><a href='/plugins/mpd/controller/Setup.php'>Click here to reload Page</a></b>";
