#!/bin/bash

# $1 is scriptpath to this plugin
export DEBIAN_FRONTEND=noninteractive

sudo apt-get update
sudo apt-get install mpd mpc alsa-utils libmpdclient-dev --yes
sudo update-rc.d mpd remove
sudo usermod -aG audio mpd

#Edit Config File to Access MPD from every computer in network and remove fixed bitrates
sed -i "s@^bind_to_address.*@bind_to_address    \"any\"@" /etc/mpd.conf
sed -i "s@^\tname\t\t\"My ALSA Device\"@\tname\t\"Max2Play ALSA Device\"\n\tdevice\t\"hw:0,0\"\n\tmixer_type\t\"hardware\"\n\tmixer_device\t\"default\"\n\tmixer_control\t\"PCM\"\n\tformat\t\"44100:16:2\"@" /etc/mpd.conf

# Get YMPD
pushd /opt; mkdir ympd; cd ympd;wget http://www.ympd.org/downloads/ympd-1.2.3-armhf.tar.bz2;tar xvjf ympd-1.2.3-armhf.tar.bz2;

# Init-Script YMPD and MPD
cp $1init-ympd /etc/init.d/init-ympd; chmod 777 /etc/init.d/init-ympd;
cp $1mpd /etc/init.d/mpd; chmod 777 /etc/init.d/mpd;
chmod 777 /opt/ympd

pushd /opt
mkdir /var/lib/mpd/music/RADIO
mkdir /var/lib/mpd/music/MOUNT
mkdir /mnt/mpd
chmod 777 /mnt/mpd
ln -s /mnt/mpd /var/lib/mpd/music/MOUNT
ln -s /media/usb0 /var/lib/mpd/music/USB

# Samba Fix for Symlinks
sed -i 's@^\[global\]@\[global\]\nfollow symlinks = yes\nwide links = yes\nunix extensions = no@' /etc/samba/smb.conf

git clone https://github.com/jprjr/internet-radio-streams.git
cd internet-radio-streams
./make_links /var/lib/mpd/music/RADIO/ pls
chown -R mpd:audio /var/lib/mpd/music/RADIO

chmod 777 /etc/mpd.conf
sed -i "s/[\t ]\+# optional//" /etc/mpd.conf

#Set Bash for user mpd for Equalizer to work
sed -i 's@/var/lib/mpd:.*@/var/lib/mpd:/bin/bash@' /etc/passwd

mpc update

#Remove from systemd autostart
systemctl disable mpd.service

echo "finished <b><a href='/plugins/mpd/controller/Setup.php'>Click here to reload Page</a></b>";
