<?php
/**
	 MPD Setup
	
	 @Copyright 2014 Stefan Rick
	 @author Stefan Rick
	 Mail: stefan@rick-software.de
 	 Web: http://www.netzberater.de

 */ 
?>											

<h1 class="entry-header">
	<?php echo _t("Music Player (MPD) Setup") ?>
</h1>
<div class="entry-content">
	<?php if(isset($mpd->view->message[0]) || isset($as->view->message[0])){ ?>
		<div class="ui-widget">
			<div class="ui-state-highlight ui-corner-all" style="margin-bottom: 10px; padding: 0.4em .7em;">
				<p>
					<span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>
					<?php echo implode('<br /><span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>', $mpd->view->message); ?>
					<?php echo implode('<br /><span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>', $as->view->message); ?>
				</p>
			</div>
		</div>
	<?php } ?>		
	<?php echo _t("Manage the Music Player MPD and control your Player with YMPD (small webclient) or Ampache (powerful webclient). You may access the locally stored Playlist/Music/Radiolists on this device from any computer in your network (via Samba). <a href=\"/plugins/max2play_settings/controller/Filesystem.php#sambashares\">Click here for more information</a>.") ?>	
	<br /><br />
	
	<form action="" method="get" id="form1">
	<input type="hidden" id="action" name="action" value="" />
	
<?php if($mpd->view->installed) { ?>			
	
	<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-volume-on" style="float:left; margin:-2px 5px 0 0;"></span>					
			<?php if ($mpd->view->pid) { ?>
				<b><?php echo _('Status') ?>:</b> <?php echo str_replace('$SERVICENAME', $mpd->viewname, _('$SERVICENAME is running with processID')) ?> <b><?php echo $mpd->view->pid ?></b></p>
				<input type="button" value="<?php echo str_replace('$SERVICENAME', $mpd->viewname, _('stop $SERVICENAME')) ?>" name="stop" onclick="document.getElementById('action').value='stopmpd';submit();" />
				<input type="button" value="<?php echo str_replace('$SERVICENAME', $mpd->viewname, _('kill $SERVICENAME')) ?>" name="kill" onclick="document.getElementById('action').value='killmpd';submit();" />
			<?php }else { ?>
				<b><?php echo _('Status') ?>:</b> <?php echo str_replace('$SERVICENAME', $mpd->viewname, _('$SERVICENAME not running')) ?></p>
				<input type="button" value="<?php echo str_replace('$SERVICENAME', $mpd->viewname, _('start $SERVICENAME')) ?>" name="start" onclick="document.getElementById('action').value='startmpd';submit();" />	
			<?php } ?>
	
	<a class="button-small" href="//<?php echo $mpd->getServerUrl($ipv4=true).':'.(($mpd->view->portympd)? $mpd->view->portympd : '8080'); ?>" target="_blank"><?php echo _t("Open Webinterface to play music (YMPD)") ?></a>
	<br /><br />
	<div id="settingsmpd" style="max-height:500px;">
		  <h3><?php echo _t('Music Player Basic Settings') ?></h3> 
		  <div>		    
			<table>
				<tr>
					<td><?php echo _('Autostart') ?></td>					
					<td><input type="checkbox" <?php if($mpd->view->autostartmpd) echo "checked"; ?> value="1" name="autostartmpd" /></td>
					<td><?php echo _t('Autostart MPD on system start') ?></td>
				</tr>
				<tr>
					<td><?php echo _t('Music directory') ?></td>					
					<td><input type="text" name="mpd[music_directory]" value="<?php echo $mpd->mpdconfig['music_directory'] ?>" /></td>
					<td><?php echo _t('Directory for your locally stored music. USB-Drives are available in the sub-folder "USB". <a href="/plugins/max2play_settings/controller/Filesystem.php#usbdrivesblock">Click here to see active USB-drives</a>.<br />To access your music on a network share, you have to <a href="/plugins/max2play_settings/controller/Filesystem.php">setup the share</a> with the mountpoint folder <b>/mnt/mpd</b>.') ?></td>
				</tr>
				<tr>
					<td><?php echo _t('Playlist directory') ?></td>					
					<td><input type="text" name="mpd[playlist_directory]" value="<?php echo $mpd->mpdconfig['playlist_directory'] ?>" /></td>
					<td><?php echo _t('Directory for your locally stored playlists. Path changes are the same as for the music directory.') ?></td>
				</tr>
				<tr>
					<td><?php echo _t('Use USB-DAC') ?></td>					
					<td><input type="checkbox" name="use_usb_dac" <?php if ($mpd->view->use_usb_dac == 1) echo "checked" ?> value="1" />
					</td>
					<td><?php echo _t('Enable "Use USB-DAC" for simultaneous usage of Kodi AND MPD - only possible if either Kodi OR MPD is using a separate Audio Output (e.g. DAC like HifiBerry/IQAudIO or USB-DAC like LogiLink) for sound. If not checked only Kodi OR MPD can run at one time.') ?></td>
				</tr>			
			</table>
			<br /><br />
		    <a class="button-small clickloading" href="#" onclick="document.getElementById('action').value='save_mpdconfig';$('#form1').submit();"><?php echo _("Save!") ?></a>
		    
		  </div>
		  
		  <h3><?php echo _t('Music Player Webinterface') ?></h3> 
		  <div>		    
			<table>
				<tr>
					<td><?php echo _t('Port YMPD') ?></td>					
					<td><input type="text" value="<?php echo $mpd->view->portympd;?>" name="portympd" /></td>
					<td><?php echo _t('Use a free Port like 8081 when Kodi is runnging at the same time (blocks 8080)') ?></td>
				</tr>	
				<tr>
					<td><?php echo _t('Autostart YMPD') ?></td>					
					<td><input type="checkbox" <?php if($mpd->view->autostartympd) echo "checked"; ?> value="1" name="autostartympd" /></td>
					<td><?php echo _t('Default webclient to control music player via webinterface and smartphone') ?></td>
				</tr>				
			</table>
		    <br /><br />
		    <a class="button-small clickloading" href="#" onclick="document.getElementById('action').value='save_mpdconfig';$('#form1').submit();"><?php echo _("Save!") ?></a>
		    
		  </div>
		  
		  <h3><?php echo _t('Music Player Soundcard Settings') ?></h3> 
		  <div>		    
			<table>
				<tr>
					<td><?php echo _t('Sound Device') ?></td>					
					<td>
						<?php /* <input type="text" name="mpd[device]" value="<?php echo $mpd->mpdconfig['device'] ?>" />*/?>
						<select name="mpdoutput[device]" style="width: 90%;" >
						<?php foreach($mpd->view->soundDevices as $soundDeviceKey => $soundDevice){ ?>
							<option <?php if($mpd->mpdconfigoutput['device'] == $soundDeviceKey) echo 'selected'; ?> value='<?php echo $soundDeviceKey ?>'><?php echo $soundDevice['name'].' - '.$soundDevice['description'].', '.$soundDevice['card']; ?></option>
						<?php }?>
						</select>
					</td>
					<td><?php echo _t('Sound Device for MPD. Use plug:plugequal for equalizer. Default: hw:0,0 for first audiocard or hw:1,0 for second card.') ?></td>
				</tr>
				<tr>
					<td><?php echo _t('Audioformat') ?></td>					
					<td><input type="text" name="mpdoutput[format]" value="<?php echo $mpd->mpdconfigoutput['format'] ?>" /></td>
					<td><?php echo _t('Samplerate and Bitrate. Default is 44100:16:2. HiFiBerry and other DACs may benefit from settings like 192000:24:2') ?></td>
				</tr>
				<tr>
					<td><?php echo _t('Mixer Device') ?></td>					
					<td><input type="text" name="mpdoutput[mixer_device]" value="<?php echo $mpd->mpdconfigoutput['mixer_device'] ?>" /></td>
					<td><?php echo _t('The Mixer device. May be hw:0 or hw:1 depending on the position of the soundcard.') ?></td>
				</tr>
				<tr>
					<td><?php echo _t('Mixer Control') ?></td>					
					<td><input type="text" name="mpdoutput[mixer_control]" value="<?php echo $mpd->mpdconfigoutput['mixer_control'] ?>" /></td>
					<td><?php echo _t('The Mixer Control. Default is PCM. HiFiBerry DACs use "Digital" and Amps "Master". When using Pulseaudio it should be "Master".') ?></td>
				</tr> 
				<?php /*?><tr>
					<td><?php echo _t('Audio buffer size (optional)') ?></td>					
					<td><input type="text" name="mpd[audio_buffer_size]" value="<?php echo $mpd->mpdconfigoutput['audio_buffer_size'] ?>" /></td>
					<td><?php echo _t('Default 2048') ?></td>
				</tr>
				<tr>
					<td><?php echo _t('Buffer before play (optional)') ?></td>					
					<td><input type="text" name="mpd[buffer_before_play]" value="<?php echo $mpd->mpdconfigoutput['buffer_before_play'] ?>" /></td>
					<td><?php echo _t('Default 10%') ?></td>
				</tr>*/?>
			</table>
		    <br /><br />
		    <a class="button-small clickloading" href="#" onclick="document.getElementById('action').value='save_mpdconfig';$('#form1').submit();"><?php echo _t("Save!") ?></a>
		    
		  </div>
	</div>
	
	<script>
	  $(function() {
	    $( "#settingsmpd" ).accordion({
	      heightStyle: "content",
	      active: false,
	      collapsible: true 
	    });   
	  });  
 	 </script>
 	  		
		
	<p class="ui-state-default ui-corner-all" style="padding:4px;margin-top:3em;">
		<span class="ui-icon ui-icon-signal" style="float:left; margin:-2px 5px 0 0;"></span>
		<?php echo _('Graphic Equalizer') ?>
	</p>
	<br />
	<?php echo _('Use Equalizer (activate settings in this webinterface)') ?> <input type="checkbox" name="use_equalizer" <?php if ($mpd->view->use_equalizer == 1) echo "checked" ?> value="1" />
	<?php if($mpd->view->use_equalizer == 1) { ?>
		
		<style>
		#eq span {
		height:120px; float:left; margin:15px
		}
		</style>
		<script>
		$(function() {
			$( "#eq > span" ).each(function() {
			// read initial values from markup and remove that
			var value = parseInt( $( this ).text(), 10 );
			var id = $( this ).attr('id');
			$( this ).empty().slider({
				value: value,
				id: id,
				range: "min",
				min: 0,
				max: 100,
				animate: true,
				orientation: "vertical",
				slide: function(event, ui) {
			        $("#selectedEqual").val( ui.value );
			        $("#selectedEqualSpan").text( id );
			    },
			    stop : function(event, ui){	        
			        $('[id="'+ id +'"]').val(ui.value);	        
			    }
				});
			});
		});
		</script>
		
		<script>		
			$(function() {
				$( "#slider-lowpass" ).slider({
					range: "min",
					min: 300,
					value: $( "#lowpass" ).attr('value'),
					max: 1000,
					slide: function( event, ui ) {
						$( "#lowpass" ).val( ui.value );
					}
				});
			});
			$(function() {
				$( "#slider-crossfeed" ).slider({
					range: "min",
					value: $( "#crossfeed" ).attr('value') * 10,
					min: 10,
					max: 150,
					slide: function( event, ui ) {
						$( "#crossfeed" ).val( ui.value / 10 );
					}
				});		
			});
		</script>
		
		<?php foreach($mpd->equalvalues as $key => $value) { ?>
			<input type="hidden" id="<?php echo $key ?>" name="settingsEqualizer[<?php echo $key ?>]" value="<?php echo $value; ?>">
		<?php } ?>
		
		<div id="eq">
			<?php foreach($mpd->equalvalues as $key => $value) { ?>
				<span id="<?php echo $key ?>"><?php echo $value ?></span>
			<?php } ?>
		</div>
		<br />
		<input type="button" value="<?php echo _('Reset') ?>" name="save" onclick="document.getElementById('action').value='resetEqualizer';submit();" /><br /><br />
		<input type="button" value="<?php echo _('save') ?>" name="save" onclick="document.getElementById('action').value='saveEqualizer';submit();" /><br />
		<br />
		<input type="text" size="2" value="" id="selectedEqual" /> <span id="selectedEqualSpan"></span>
	<?php } else { ?>
		<input type="button" value="<?php echo _('save') ?>" name="save" onclick="document.getElementById('action').value='saveEqualizer';submit();" />
	<?php } ?>
	<br /><br /> 
 	 
<?php }else { ?>	
	<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-wrench" style="float:left; margin:-2px 5px 0 0;"></span>
					<?php echo _t("MPD is NOT installed yet!") ?>			
			</p>
	<b><?php echo _t("Install latest version of Music Player Deamon (MPD)") ?></b>
	<br />
	<input type="button" value="<?php echo _('install') ?>" name="install" onclick="document.getElementById('action').value='install';submit();" />
	
<?php } ?>

	<br /><br />
	<?php include_once('ampache.php'); ?>
	
	</form>

	<br /><br />
	<a href="#javascript" onclick="document.getElementById('debug').style.display='';return false;">DEBUG Info</a><br />
	<textarea id="debug" rows="30" cols="70" style="display:none;"><?php foreach ($mpd->view->debug as $key => $debug) {
			echo "#### ". $key. " ####\n"; 
			 echo $debug." \n\n"; 
		 }?>
	</textarea>

</div>	